Index: src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java	(revision 4872)
+++ src/uk/me/parabola/imgfmt/app/mdr/MDRFile.java	(working copy)
@@ -76,7 +76,6 @@
 
 	private final MdrSection[] sections;
 	private PointerSizes sizes;
-	private Set<String> mdr7Del;
 
 	private Set<Integer> poiExclTypes; 
 
@@ -85,7 +84,6 @@
 
 		forDevice = config.isForDevice();
 		isMulti = config.getSort().isMulti();
-		mdr7Del = config.getMdr7Del();
 		poiExclTypes = config.getPoiExclTypes();
 		mdrHeader = new MDRHeader(config.getHeaderLen());
 		mdrHeader.setSort(sort);
@@ -243,27 +241,6 @@
 				continue;
 			
 			String name = lab.getText();
-			if (!mdr7Del.isEmpty()) {
-				String[] parts = name.split(" ");
-				int pos = parts.length;
-				for (int i = parts.length - 1; i >= 0; i--) {
-					if (!mdr7Del.contains(parts[i])) {
-						break;
-					}
-					pos = i;
-				}
-				if (pos == 0)
-					continue;
-				if (pos < parts.length) {
-					StringBuilder sb = new StringBuilder();
-					for (int i = 0; i + 1 < pos; i++) {
-						sb.append(parts[i]);
-						sb.append(" ");
-					}
-					sb.append(parts[pos - 1]);
-					name = sb.toString(); // XXX maybe add -intern()
-				}
-			}
 			
 			int strOff = createString(name);
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java	(revision 4872)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java	(working copy)
@@ -57,6 +57,7 @@
 	private int maxSuffixCount;
 	private boolean magicIsValid;
 	private int magic;
+	private Set<String> mdr7Del;
 
 	public Mdr7(MdrConfig config) {
 		setConfig(config);
@@ -64,6 +65,7 @@
 		collator = sort.getCollator();
 		splitName = config.isSplitName();
 		exclNames = config.getMdr7Excl();
+		mdr7Del = config.getMdr7Del();
 		codepage = sort.getCodepage();
 		isMulti = sort.isMulti();
 	}
@@ -164,7 +166,12 @@
 			lastMaxIndex = st.getMapIndex();
 			roadsPerMap.clear(); 
 		}
-		
+		final String part = st.getPartialName();
+		int pos = part.indexOf(' ');
+		if (pos < 0 && mdr7Del.contains(part))
+			return;
+		if (pos >= 0 && mdr7Del.contains(part.substring(0, pos)))
+			return;
 		if (roadsPerMap.add(st)) {
 			allStreets.add(st);
 		}
